#ifndef MOBILE_SDK_API_AD_INTERFACE_H_
# define MOBILE_SDK_API_AD_INTERFACE_H_

#include "MobileSDK/ad/AdUtils.h"
#include "MobileSDK/common/Utils.h"

typedef struct msdk_AdInterface
{
	void(*Init)();
	msdk_Status(*StatusInit)();
	msdk_Result(*ResultInit)();
	void(*ReleaseInit)();

	void(*CallPreload) (struct msdk_AdInterface*);
	void(*Display) (struct msdk_AdInterface*);
	void(*Visibility) (struct msdk_AdInterface*, char p_visibility);
	void(*Delete) (struct msdk_AdInterface*);
	struct msdk_AdInterface* (*CreateInstance)(void);
	void (*DestroyInstance)(struct msdk_AdInterface*);
	const char_utf8* (*GetRewardCheckURL)(struct msdk_AdInterface*);

	const char_utf8*	name;

	Array_msdk_AdEvent*	events;
	msdk_AdType			adType;
	msdk_AdView			adView;
	msdk_Status			preloadStatus;
	msdk_Result			preloadResult;
	msdk_s8				adId;
	char				isClicked;

	void*				internals;
    const char_utf8*    currencyId;
}msdk_adInterface;

#endif //MOBILE_SDK_API_AD_INTERFACE_H_
