#ifndef MOBILE_SDK_API_AD_UTILS_H_
# define MOBILE_SDK_API_AD_UTILS_H_

#include "MobileSDK/common/Utils.h"

#ifdef UBI_ANDROID
#include <jni.h>
#elif defined(UBI_IOS)
#import <UIKit/UIKit.h>
#endif

enum msdk_AdType
{
	MSDK_URGENT_NEWS, // Magnet
	MSDK_FULL_SCREEN_ADS, // Magnet, Flurry, Tapjoy
	MSDK_FULL_SCREEN_ADS_REWARDED, // Flurry, Tapjoy
	MSDK_BANNER_BOTTOM, // Flurry
	MSDK_BANNER_TOP, // Flurry
	MSDK_BANNER_BOTTOM_REWARDED, // Flurry
	MSDK_BANNER_TOP_REWARDED, // Flurry
	MSDK_OFFERWALL // Flurry, Tapjoy
};

const char_utf8* msdk_AdType_String(msdk_AdType p_type);

enum msdk_AdEvent
{
	MSDK_AD_EVENT_CLICKED,
	MSDK_AD_EVENT_DID_OPEN,
	MSDK_AD_EVENT_DID_CLOSE,
};

typedef struct msdk_VirtualCurrency
{
	const char_utf8*	name;
	msdk_u32			value;
}msdk_VirtualCurrency;

///
/// Helper function to convert a msdk_AdEvent into a string (Useful for debug logs)
/// @param p_status a value of msdk_AdEvent
/// @return a string equal to the value gave in parameter
///
const char_utf8* const msdk_AdEvent_string	(msdk_AdEvent p_event);

#include "MobileSDK/common/Array.inl"
DECLARE_ARRAYS(msdk_AdEvent);
DECLARE_ARRAYS(msdk_VirtualCurrency);

const char_utf8* msdk_AdType_String(msdk_AdType p_type);

#ifdef UBI_IOS
typedef UIView* msdk_AdView;
#elif defined(UBI_ANDROID)
typedef jobject msdk_AdView;
#elif defined(UBI_WIN8) || defined(UBI_WP8)
typedef void* msdk_AdView;
#endif

typedef struct msdk_AdInfo
{
	// Ad type
	msdk_AdType         type;
	// Position on the screen
	msdk_AdView         adView;
    // Optional currency name to use
    const char_utf8*    currencyName;
}msdk_AdInfo;

extern void Ad_UpdatePreload(msdk_s8, msdk_Result);
extern void Ad_UpdateEvents(msdk_s8, msdk_AdEvent);

#endif //MOBILE_SDK_API_AD_UTILS_H_
