#ifndef MOBILE_SDK_MEM_INTEFACE_H_
#define MOBILE_SDK_MEM_INTEFACE_H_
#include "MobileSDK/common/Utils.h"
///
/// Structure to pass in order to use a custom memmory allocator
/// Contains functon pointers to allocation functions
///
typedef struct msdk_MemInterface
{
    #ifdef MSDK_BUILD_PROFILE
        void* (*Alloc) (size_t, const char*, int, const char*);
        void* (*Realloc) (void*, size_t, const char*, int, const char*);
        void (*Free)(void*, const char*, int, const char*);
    #else
        void* (*Alloc) (size_t);
        void* (*Realloc) (void*, size_t);
        void (*Free)(void*);
    #endif
    void* (*AllocAligned) (size_t, size_t);
	void* (*ReallocAligned) (void*, size_t, size_t);
	char (*Protect) (void*, size_t);
	char (*UnProtect) (void*, size_t);

    size_t (*GetMaxAllocationSize) ();
    size_t (*GetAlignement) ();
	const char_utf8* (*GetName) ();

	msdk_u32 			m_systemMemoryAllocated;
	char 				m_id;
	const char_utf8* 		m_customName;

}msdk_MemInterface;

#endif //! MOBILE_SDK_MEM_INTEFACE_H_
