#ifndef GETTING_STARTED_W8
#define GETTING_STARTED_W8
/// @page getting_started_win8 win8
/// If you want to use the MobileSDK on Windows 8 you need to use a Xaml cpp solution (needed for the Facebook's webviews).
///
/// Add MobileSDK.lib as Additional linker dependency. Add its containing folder as Additional Library Directory.
/// You should define the preprocessor macro : UBI_WIN8
///
/// Add FlurryWin8SDK, SQLite and Xbox Live SDK as references (see more about Xbox Live SDK below).
///
/// You can download and install SQLite for Windows 8.0/8.1 at <a href="http://www.sqlite.org/download.html">link</a>
///
/// @section wp8_xbox_live_setup XboxLive setup for Windows 8.0/8.1
/// In order to develop for XboxLive on Windows 8 several things are required :
/// <ul>
/// <li>Xbox Live SDK for Windows 8 and its documentation (will allow you to add a reference to XboxLiveSDK in your project)</li>
/// <li>Xbox Live Publishing Toolkit (allows to manage the achievements, leaderboard, etc.)</li>
/// <li>A Microsoft developer account</li>
/// <li>An XboxLive developer account linked with your Microsoft account and your titleId</li>
/// </ul>
/// Make a request to Digital Certification to get these "tools".
///
/// 1) Install the SDK and the Publishing toolkit
///
/// 2) Create and XboxLive configuration file (.spa) and add it to your project (select Content true in properties)
///
/// 3) Go to C:\Program Files\Microsoft SDKs\Windows\v8.0\ExtensionSDKs\Xbox LIVE SDK for Windows\1.0 and right click on SwitchToInt.cmd then "Run as administrator"
///
/// 4) Connect with your Microsoft developer account into Windows.
///
/// 5) Add Xbox Live SDK for Windows as reference to your project
///
/// 6) Open package.appmanifest with a text editor and add this :
/// @code {.xml}
/// <Extensions>
///    <Extension Category="windows.activableClass.proxyStub">
///	 	  	<ProxyStub ClassId="10EE0CAA-F78A-4AE6-A92C-8988E2DEDB00">
///				<Path>microsoft.Xbox.dll</Path>
///				<Interface Name="Microsoft.Xbox.Interop.ICallbackInvoker" interfaceId="3DBDEF74-8B05-4318-8A5C-D790039C0576" />
///			</ProxyStub>
///    </Extension>
/// </Extensions>
/// @endcode
///
/// 7) Add Internet(client) as capapility
///
/// 8) Add the config.json file located in the misc folder, add it to your project, select Content and "Copy if newer" in the properties tab
///
/// You should be all set to use XboxLive on Windows 8. For more informations please reffer to the official windows documentation.
///

#endif

