#ifndef MOBILE_SDK_API_IAP_PROVIDER_H
# define MOBILE_SDK_API_IAP_PROVIDER_H

#include "MobileSDK/common/Utils.h"
#include "MobileSDK/common/Init.h"
#include "MobileSDK/iab/IAPProduct.h"
#include "MobileSDK/iab/IAPManager.h"

typedef struct msdk_IabInterface
{
	// Init

	void 		(*IabProvider_CallInit)			(Array_msdk_IAPProduct* p_products);
	msdk_Status (*IabProvider_StatusInit)		();
	msdk_Result (*IabProvider_ResultInit)		();
	void 		(*IabProvider_ReleaseInit)		();
	void 		(*IabProvider_UpdateProducts)	();

	msdk_s8 				(*IabProvider_CallBuyItem)		(const char_utf8* p_productId);
	msdk_Status				(*IabProvider_StatusBuyItem)	(msdk_s8 p_requestId);
	msdk_PurchaseResult* 	(*IabProvider_ResultBuyItem)	(msdk_s8 p_requestId);
	void 					(*IabProvider_ReleaseBuyItem)	(msdk_s8 p_requestId);

    void                    (*IabProvider_CallBuyPack)       (const char_utf8* p_packId);
    msdk_Status				(*IabProvider_StatusBuyPack)	();
    msdk_PurchaseResult* 	(*IabProvider_ResultBuyPack)	();
    void 					(*IabProvider_ReleaseBuyPack)	();

    msdk_s8                 (*IabProvider_CallValidateReceipt)(const char_utf8* p_receipt, const char_utf8* p_productIdentifier, const char_utf8* p_formattedPrice);
    msdk_Status             (*IabProvider_StatusValidateReceipt)(msdk_s8 p_requestId);
    msdk_ReceiptResult*     (*IabProvider_ResultValidateReceipt)(msdk_s8 p_requestId);
    void                    (*Iabprovider_ReleaseValidateReceipt)(msdk_s8 p_requestId);

    void                    (*IabProvider_CallRestorePacks)         ();
    msdk_Status				(*IabProvider_StatusRestorePacks)       ();
    Array_msdk_PurchaseResult* 	(*IabProvider_ResultRestorePacks)	();
    void 					(*IabProvider_ReleaseRestorePacks)      ();

    void                    (*IabProvider_CallValidateItem)		(const char_utf8* p_productId);
	msdk_Status				(*IabProvider_StatusValidateItem)	(const char_utf8* p_productId);
	msdk_PurchaseResult* 	(*IabProvider_ResultValidateItem)	(const char_utf8* p_productId);
	void 					(*IabProvider_ReleaseValidateItem)	(const char_utf8* p_productId);

	msdk_s8 				(*IabProvider_CallConsumeItem)		(const char_utf8* p_productId);
	msdk_Status				(*IabProvider_StatusConsumeItem)	(msdk_s8 p_requestId);
	msdk_PurchaseResult* 	(*IabProvider_ResultConsumeItem)	(msdk_s8 p_requestId);
	void 					(*IabProvider_ReleaseConsumeItem)	(msdk_s8 p_requestId);

	void					(*IabProvider_CallRefreshItems)		();
	msdk_Status				(*IabProvider_StatusRefreshItems)	();
	msdk_Result				(*IabProvider_ResultRefreshItems)	();
	void 					(*IabProvider_ReleaseRefreshItems)	();

    msdk_s8                 (*IabProvider_CanDestroy)           ();

	// Return all the item that may be purchase (even if they are managable and owned)
	const Array_msdk_IAPProduct* (*IabProvider_KnownItems)		();

	void 		(*IabProvider_Destroy)		();

    Array_msdk_IAPProduct*  (*IabProvider_GetTransactionHistoric)   ();
    void                    (*IabProvider_ClearTransactionFromHistoric) (const char_utf8*);
    void                    (*IabProvider_ClearTransactionHistoric) ();

    const char_utf8*        (*IabProvider_StoreCountryCode)();
    
    msdk_Status             (*IabProvider_SilentUpdateStatus)();

}msdk_IabInterface;




#endif // MOBILE_SDK_API_AD_H_
