#ifndef MOBILE_SDK_API_USERSCORE_H
#define MOBILE_SDK_API_USERSCORE_H

#include "MobileSDK/common/utils.h"
#include "MobileSDK/social/UserInfo.h"

// For transition period from UserScore to Score
#define msdk_UserScore msdk_Score
#define PointerArray_msdk_UserScore PointerArray_msdk_Score
#define Array_msdk_UserScore Array_msdk_Score

///
/// Contains field to store score's infos
///
typedef struct msdk_Score
{
    char_utf8*       title;     //!< The name of the score
    msdk_UserInfo*   userInfo;  //!< The user who owns this score
    char_utf8*       value;     //!< The value of the score
    msdk_u32         rank;      //!< The rank of the user
    msdk_u32         rawValue;  //!< The value of the score as an integer without the score type
    msdk_Service     service;
    const char_utf8* leaderboardId;
    const char_utf8* name;
    const char_utf8* group;
    const char_utf8* country;
    const char_utf8* extra;
}msdk_Score;

#include "MobileSDK/common/Array.inl"
DECLARE_ARRAYS(msdk_Score)

msdk_Score* msdk_Score_Create();
void        msdk_Score_Init(msdk_Score*);
void 		msdk_Score_Copy(msdk_Score* src, msdk_Score* dest);
void		msdk_Score_Release(msdk_Score* score);

#endif // MOBILE_SDK_API_USERSCORE_H

