#ifndef MOBILE_SDK_API_FLURRY_TRACKING_H
# define MOBILE_SDK_API_FLURRY_TRACKING_H

#include "MobileSDK/common/Utils.h"

#ifdef __cplusplus
extern "C"
{
#endif

    ///
    /// Activate Flurry as tracking services
    ///
    MSDK_EXPORT    void    Analytics_ActivateFlurry();

    ///
    /// Set the age of the user for the Flurry tracking
    /// @param p_age The age of the user
    ///
    MSDK_EXPORT    void    Flurry_SetAge(msdk_u8 p_age);

    ///
    /// Activate/Unactivate the logs for Flurry
    /// @param p_activate MSDK_TRUE if you want the logs to be activated, MSDK_FALSE otherwise
    ///
    MSDK_EXPORT    void    Flurry_ActivateLogs(msdk_s8 p_activate);

#ifdef __cplusplus
}
#endif

#endif
