#ifndef MOBILESDKPRIVATE_COMMON_DEFAULTALLOCATOR
#define MOBILESDKPRIVATE_COMMON_DEFAULTALLOCATOR

#include "MobileSDKprivate/common/Utils.h"

#ifdef __cplusplus
extern "C"
{
#endif
	void* DefaultAllocator_Alloc(size_t p_size);

	void* DefaultAllocator_AllocAligned(size_t p_size, size_t p_alignement);

	void* DefaultAllocator_Realloc(void* p_oldPtr, size_t p_size);

	void* DefaultAllocator_ReallocAligned(void* p_oldPtr, size_t p_size, size_t p_alignement);

	void DefaultAllocator_Free(void* p_ptr);

	size_t DefaultAllocator_GetMaxAllocationSize();

	size_t DefaultAllocator_GetAlignment();

	const char_utf8* DefaultAllocator_GetName();

    void* DefaultAllocator_AllocProfiled(size_t p_size, const char* p_file, int p_line, const char* p_func);

    void* DefaultAllocator_ReallocProfiled(void* p_oldPtr, size_t p_size, const char* p_file, int p_line, const char* p_func);

    void DefaultAllocator_FreeProfiled(void* p_ptr, const char* p_file, int p_line, const char* p_func);

#ifdef __cplusplus
} // extern "C"
#endif

#endif //! MOBILE_SDK_DEFAULT_ALLOCATOR_H
