#ifndef MOBILESDKPRIVATE_COMMON_FILESYSTEM
#define MOBILESDKPRIVATE_COMMON_FILESYSTEM
//	#include "MobileSDK/common/FileSystem.h"

#include "MobileSDKprivate/common/Utils.h"
#include "MobileSDKprivate/common/FileSystemInterface.h"

#ifdef __cplusplus
extern "C"
{
#endif

	// -------------------------------------------------------------------------
	// FileSystem Errors and Constants

	// -------------------------------------------------------------------------
	// Files
	const char* FilePath(char_utf8 const* p_fullname, msdk_FileArea p_type);
	
	char						FileExist(const char_utf8* p_fullname, msdk_FileArea p_fileType);
	msdk_FileStruct*			FileOpen	(const char_utf8* p_fullname, msdk_u32 p_mode, msdk_FileArea p_filetype);
	size_t						FileSize	(msdk_FileStruct* p_fileHandle);
	size_t						FileRead	(msdk_FileStruct* p_fileHandle, void* p_buffer, msdk_u32 p_bufferSize);
	size_t						FileSeek	(msdk_FileStruct* p_fileHandle, size_t p_offset, msdk_FileSeekOrigin p_origin);
	size_t						FileWrite	(msdk_FileStruct* p_fileHandle, const void* p_buffer, msdk_u32 p_bufferSize);
	char						FileClose	(msdk_FileStruct* p_fileHandle);
	#ifdef UBI_WIN8
	void						AddFileToLoad (const char_utf8 * p_fullname);
	#endif
	// -------------------------------------------------------------------------
	// Directories
	char						DirectoryExist		(const char_utf8* p_fullname, msdk_FileArea p_type);
	char						DirectoryCreate		(const char_utf8* p_fullname, msdk_FileArea p_type, msdk_u16 p_mode);
	msdk_DirectoryStruct*		DirectoryOpen		(const char_utf8* p_fullname, msdk_FileArea p_type);
	char						DirectoryClose		(msdk_DirectoryStruct* p_dirHandle);
	char						DirectoryGetFirst	(msdk_DirectoryStruct* p_dirHandle, msdk_DirectoryEntry* p_dirEntry);
	char						DirectoryGetNext	(msdk_DirectoryStruct* p_dirHandle, msdk_DirectoryEntry* p_dirEntry);

#ifdef UBI_ANDROID
	// TODO Set the java activity here
#endif

	const msdk_FileSystemInterface*	GetDefaultFileSystem();
	const msdk_AreaPermissions*		GetDefaultPermissions();
#ifdef __cplusplus
}
#endif

#endif //! MOBILESDK_FILE_SYSTEM_H_
