#ifndef MOBILESDKPRIVATE_COMMON_FILESYSTEMMANAGER
#define MOBILESDKPRIVATE_COMMON_FILESYSTEMMANAGER

#include "MobileSDKprivate/common/Utils.h"
#include "MobileSDKprivate/common/FileSystemInterface.h"

extern const	msdk_FileSystemInterface*		m_fileInterface;
extern const	msdk_AreaPermissions*			m_permissions;

#if defined(UNITY_SCRIPT) || defined(UNITY_BINDING)
	const msdk_FileSystemInterface* get_m_fileInterface();
	void set_m_fileInterface(const msdk_FileSystemInterface*);

	const msdk_AreaPermissions* get_m_permissions();
	void set_m_permissions(const msdk_AreaPermissions*);
#endif

#ifdef __cplusplus
extern "C"
{
#endif

	void FileSystem_Register(const msdk_FileSystemInterface*, const	msdk_AreaPermissions*);

	extern char						(*msdk_FileExist)(char_utf8 const* p_fullname, msdk_FileArea p_fileArea);
	extern msdk_FileStruct*			(*msdk_FileOpen)(char_utf8 const* p_fullname, msdk_u32 p_mode, msdk_FileArea p_fileArea);
	extern size_t					(*msdk_FileSize)(msdk_FileStruct* p_fileHandle);
	extern size_t					(*msdk_FileRead)(msdk_FileStruct* p_fileHandle, void* p_buffer, msdk_u32 p_bufferSize);
	extern size_t					(*msdk_FileSeek)(msdk_FileStruct* p_fileHandle, size_t p_offset, msdk_FileSeekOrigin p_origin);
	extern size_t					(*msdk_FileWrite)(msdk_FileStruct* p_fileHandle, void const* p_buffer, msdk_u32 p_bufferSize);
	extern char						(*msdk_FileClose)(msdk_FileStruct* p_fileHandle);

	extern char						(*msdk_DirectoryExist)(char_utf8 const* p_fullname, msdk_FileArea p_type);
	extern char						(*msdk_DirectoryCreate)(char_utf8 const* p_fullname, msdk_FileArea p_type, msdk_u16 p_mode);
	extern msdk_DirectoryStruct*		(*msdk_DirectoryOpen)(char_utf8 const* p_fullname, msdk_FileArea p_type);
	extern char						(*msdk_DirectoryClose)(msdk_DirectoryStruct* p_dirHandle);
	extern char						(*msdk_DirectoryGetFirst)(msdk_DirectoryStruct* p_dirHandle, msdk_DirectoryEntry* p_dirEntry);
	extern char						(*msdk_DirectoryGetNext)(msdk_DirectoryStruct* p_dirHandle, msdk_DirectoryEntry* p_dirEntry);

#ifdef __cplusplus
}
#endif

#endif //! MOBILE_SDK_API_FILE_SYSTEM_MANAGER_H_
