#ifndef MOBILESDKPRIVATE_COMMON_INIT
#define MOBILESDKPRIVATE_COMMON_INIT
	#include "MobileSDK/common/Init.h"

#ifdef MSDK_BUILD_LIB
    #include "MobileSDKprivate/common/Thread.h"
	#include "MobileSDKprivate/common/db/UserPreferences.h"
	#include "MobileSDKprivate/common/db/ProductPreferences.h"
    #include "MobileSDKprivate/common/db/DBManager.h"
#ifdef UBI_IOS
	#import <UIKit/UIKit.h>
	#endif
	typedef enum msdk_ApplicationState {
		MSDK_FOREGROUND,
		MSDK_BACKGROUND
	} msdk_ApplicationState;

	extern msdk_ApplicationState msdkApplicationState;

	extern const	char_utf8*	MSDK_APPSPERSE_ID;
	extern const	char_utf8*	MSDK_GOOGLEPLAY_DEVELOPER_PUBLIC_KEY;
	extern const	char_utf8*	MSDK_TAPJOY_APP_ID;
	extern const	char_utf8*	MSDK_TAPJOY_APP_SECRET;
	extern const	char_utf8*	MSDK_GOOGLE_ANALYTICS_APP_ID;
	extern const	char_utf8*	MSDK_FLURRY_APP_ID;
	extern const	char_utf8*	MSDK_APPLICATION_NAME;
	extern const	char_utf8*	MSDK_FACEBOOK_NAMESPACE;
	extern const	char_utf8*	MSDK_FACEBOOK_APP_ID;
    extern const	char_utf8*	MSDK_FACEBOOK_PERMISSIONS;
    extern const	char_utf8*	MSDK_FACEBOOK_PERMISSIONS_READ;
    extern const	char_utf8*	MSDK_FACEBOOK_PERMISSIONS_PUBLISH;
	extern const	char_utf8*	MSDK_FACEBOOK_ACCESS_TOKEN;
	extern const	char_utf8*	MSDK_FACEBOOK_ACCESS_TOKEN_EXPIRE;
	extern const	char_utf8*	MSDK_PORTAL;
	extern const	char_utf8*	MSDK_TAPJOY_REWARD_CHECK;
	extern const	char_utf8*	MSDK_GOOGLE_RECEIPT_VALIDATION;
	extern const	char_utf8*	MSDK_FLURRY_REWARD_CHECK;
	extern const	char_utf8*	MSDK_APPLE_RECEIPT_VALIDATION;
	extern const	char_utf8*	MSDK_AMAZON_RECEIPT_VALIDATION;
	extern const	char_utf8*	MSDK_TRIALPAY_REWARD_CHECK;
	extern const	char_utf8*	MSDK_TRIALPAY_OFFERWALL_ID;
	extern const	char_utf8*	MSDK_TRIALPAY_INTERSTITIAL_ID;
	extern const	char_utf8*  MSDK_GAME_SERVICES_ACCESS_TOKEN;

	extern const	char_utf8*	MSDK_AD_CAMPAIGN_NAME;
	extern const	char_utf8*	MSDK_AD_FREE_AMOUNT_THRESHOLD;
	extern const	char_utf8*	MSDK_AD_FREE_AMOUNT_AVAILABILITY;
	extern const	char_utf8*	MSDK_AD_FREE_DISPLAY_THRESHOLD;
	extern const	char_utf8*	MSDK_AD_FREE_DISPLAY_AVAILABILITY;
	extern const	char_utf8*	MSDK_INTERSTITIAL_MIN_DELAY;
	extern const	char_utf8*	MSDK_BANNER_ROTATION_RATE;
	extern const	char_utf8*	MSDK_BANNER_FADE_IO_RATE;
	extern const	char_utf8*	MSDK_STORE_VISITS;
	extern const	char_utf8*	MSDK_ENVIRONMENT;
	extern const	char_utf8*	MSDK_ENVIRONMENT_PROD;

	extern const	char_utf8*	MSDK_GLOBAL_PLAYTIME;
	extern const	char_utf8*	MSDK_PRODUCT_ID;
	extern const	char_utf8*	MSDK_GAME_VERSION;

	extern const	char_utf8*	MSDK_SQLITE_LOCATION;

	extern const	char_utf8*	MSDK_ADCONFIG_URL;

	extern const	char_utf8*	MSDK_USER_PROFILE_URL;
	extern const	char_utf8*	MSDK_GAME_SERVER_URL;

	extern const	char_utf8*	MSDK_CACERT_FILE;
	extern const	char_utf8*	MSDK_CACERT_FIELD;

	extern const    char_utf8*  MSDK_MONEY_SPENT;
	extern const    char_utf8*  MSDK_DYNAMIC_STORE;

	extern const 	char_utf8*	MSDK_SAMSUNG_IAP_GROUP;

	extern const 	char_utf8*	MSDK_GAME_CIRCLE_ACTIVATION;
	extern const 	char_utf8*	MSDK_GAME_SERVICES_ACTIVATION;
	extern const 	char_utf8*	MSDK_GAME_CENTER_ACTIVATION;
	extern const 	char_utf8*	MSDK_SINA_WEIBO_ACTIVATION;
	extern const    char_utf8*  MSDK_PUSH_NOTIFICATION_ACTIVATION;
	extern const    char_utf8*  MSDK_PUSH_NOTIFICATION_REGISTRATION_STATE;
	extern const    char_utf8*  MSDK_GAME_CENTER_ACHIEVEMENT_IMAGE_DOWNLOAD;
	extern const    char_utf8*  MSDK_GAME_CENTER_FRIEND_IMAGE_DOWNLOAD;

	extern const    char_utf8*  MSDK_GAME_CONFIG_URL;

	extern const    char_utf8*  MSDK_GCM_SENDER_ID;

	extern const    char_utf8*  MSDK_PLAYER_FIRST_CONNECTION;

	extern const	char_utf8*  MSDK_WINDOWS_RECEIPT_VALIDATION;

	extern const    char_utf8*  MSDK_USER_PROFILE_LAST_ID;
	extern const    char_utf8*  MSDK_USER_PROFILE_NAME;
	extern const    char_utf8*  MSDK_USER_PROFILE_REFUSED_FED;

	extern const 	char_utf8*	MSDK_ANDROID_PUSH_ID;

	extern const 	char_utf8*	MSDK_WEIBO_APP_ID;
	extern const 	char_utf8*	MSDK_WEIBO_APP_SECRET;
	extern const 	char_utf8*	MSDK_WEIBO_USER_TOKEN;
	extern const    char_utf8*  MSDK_WEIBO_REDIRECT_URI;
	extern const	char_utf8*	MSDK_WEIBO_USER_TOKEN_EXPIRATION;

	extern const    char_utf8*  MSDK_UBISERVICES_APP_ID;
	extern const    char_utf8*  MSDK_UBISERVICES_APP_VERSION;

    extern const    char_utf8*  MSDK_HOUSTON_LEADERBOARD;

	// ==================================================================================
	// Mobile SDK internal stuff
	namespace MobileSDKAPI
	{

		class Init
		{
			// --------------------------------------------------------------------------
			// Public attributs
			public:
			static msdk_Mode							s_mode;
			static std::list<callback>					s_releaseFunctions;
			static std::list<callback>					s_pauseFunctions;
			static std::list<callback>					s_resumeFunctions;
			static UserPreferences						s_UserPreferences;
			static ProductPreferences					s_ProductPreferences;
			static const char_utf8*						s_sqliteKey;

			static msdk_u32								s_storeVisits;
			static msdk_u32								s_nItemsBought;
	        static char_utf8*     		                s_sessionStartDate;
			static msdk_u32								s_sessionStartTime;
	        static MobileSDKAPI::ThreadStruct           s_updateDbThread;
	        static std::map<msdk_Service, bool>         s_services;
	        static charCharMap                          s_houstonParameters;

	        static msdk_Status                          s_statusInit;

			#ifdef UBI_ANDROID
				static 	JavaVM* 	m_javaVM;
				static	jobject		m_androidActivity;
			#endif // UBI_ANDROID


			// --------------------------------------------------------------------------
			// Public functions
			public:

			static 	void DeallocateMemory();

            static void UpdateProductPreferences(sqlite3*);
            static void UpdateStore(sqlite3*);
            
			static void CommonInit(const msdk_InitializationFields* const p_initializationfields);
			static void CommonPause();
			static void CommonResume();

			static void CommonUninit();

			static void RegisterReleaseFunction(callback);
			static void UnregisterReleaseFunction(callback);

			static void RegisterPauseFunction(callback);
			static void UnregisterPauseFunction(callback);

			static void RegisterResumeFunction(callback);
			static void UnregisterResumeFunction(callback);

			#ifdef UBI_IOS
			typedef msdk_s8  (*openUrlCallback)(UIApplication *application, NSURL *url, NSString * sourceApplication, id annotation);
			static std::list<openUrlCallback> s_openUrlFunctions;
			static void RegisterIosOpenUrlFunction(openUrlCallback);
            
			#elif UBI_ANDROID
			typedef void  (*activityCallback)(msdk_s32 requestCode, msdk_s32 resultCode, jobject intentData);
			static std::list<activityCallback> s_activityResultFunctions;
			static void RegisterAndroidOnActivityResultFunction(activityCallback);

			typedef void  (*pauseCallback)();
			static std::list<pauseCallback> s_pauseCallbacks;
			static void RegisterAndroidOnPauseCallback(pauseCallback p_cb);

			typedef void  (*resumeCallback)();
			static std::list<resumeCallback> s_resumeCallbacks;
			static void RegisterAndroidOnResumeCallback(resumeCallback p_cb);
			#elif UBI_WP8
			typedef void  (*handleUrlCallback)(const wchar_t* p_url);
			static std::list<handleUrlCallback> s_handleUrlFunctions;
			static void RegisterWp8HandleUrlFunction(handleUrlCallback);
			#endif

			// --------------------------------------------------------------------------
		};
	}
#endif
// ==================================================================================

#endif // MOBILE_SDK_API_INIT_H
