#ifndef MOBILESDKPRIVATE_COMMON_DB_DBMANAGER
#define MOBILESDKPRIVATE_COMMON_DB_DBMANAGER

#include "MobileSDKprivate/common/Utils.h"
#include "MobileSDKprivate/common/CriticalSection.h"
#ifdef UBI_ANDROID
	#include "sqlite3.h"
#else
	#include <sqlite3.h>
#endif

class DBManager
{
public:
	static DBManager& GetInstance()
	{
		static DBManager instance;
		return instance;
	}

	bool        Connect(const char_utf8* p_dbPath);
	void        Disconnect();
	sqlite3*    GetHandler();
    void        ReleaseHandler();
	void        CreateKeyValueTable(const char_utf8* p_name);
private:
	DBManager();
	DBManager(DBManager const&);
	void operator=(DBManager const&);
	sqlite3*	m_db;
    MobileSDKAPI::CriticalSectionStruct lock;
};

#endif // MOBILESDKAPI_DB_MANAGER_H_
