#ifndef MOBILESDKPRIVATE_COMMON_DB_KEYVALUETABLE
#define MOBILESDKPRIVATE_COMMON_DB_KEYVALUETABLE

#include "MobileSDKprivate/common/db/DBTable.h"

class KeyValueTable : public DBTable
{
protected:
	std::map<char_utf8*, char_utf8*, CharCompFunctor>   m_fields;
    bool                                                m_loaded;
public:
	KeyValueTable();
	KeyValueTable(const char_utf8*);
	~KeyValueTable();
	virtual bool Persist();
	virtual bool Load();
	virtual void UpdateKey(const char_utf8* p_key, const char_utf8* p_value);
	virtual void DeleteKey(const char_utf8* p_key);
    virtual void DeleteAll();
	virtual const char_utf8* GetValue(const char_utf8* p_key);
    virtual msdk_FileContent Export();
    virtual bool Import(const char_utf8* p_dump, msdk_u32 p_size);
    const std::map<char_utf8*, char_utf8*, CharCompFunctor>& GetTable();
    void    ReleaseTable();
    inline  bool    IsLoaded() { return m_loaded; };
};
#endif // MOBILESDK_API_KEYVALUETABLE_H_
