#ifndef MOBILESDKPRIVATE_COMMON_DB_MERGEENTRY
#define MOBILESDKPRIVATE_COMMON_DB_MERGEENTRY

#include "MobileSDKprivate/common/db/DBTable.h"
#include "MobileSDKprivate/common/Utils.h"


class MergeEntry: public DBTable
{
public:
    enum EntryType
    {
        MSDK_ENTRY_DECLINED = 0,
        MSDK_ENTRY_CONNECTED
    };
private:
	char_utf8*	m_networkId;
	char_utf8*	m_lastUserId;
	char_utf8*	m_date;
    EntryType   m_entryType;
    char_utf8*	m_excludedForFedId;
public:
    MergeEntry();
    ~MergeEntry();
    static void     CreateTable();
    static std::vector<MergeEntry*>     GetLastConnected();
    static MergeEntry*     GetDeclinedByUserId(const char_utf8* p_userId, const char_utf8* p_forFedId);
	bool            Persist();

	inline const char_utf8* GetNetworkId() { return m_networkId; };
	inline const char_utf8* GetLastUserId() { return m_lastUserId; };
	inline const char_utf8* GetDate() { return m_date; };
    inline EntryType GetEntryType() { return m_entryType; };

	void SetNetworkId(const char_utf8* p_value);
	void SetLastUserId(const char_utf8* p_value);
	void SetDate(const char_utf8* p_value);
    void SetEntryType(EntryType p_value);
    void SetExcludedForFedId(const char_utf8* p_value);
};

#endif
