#ifndef MOBILESDKPRIVATE_COMMON_DB_STORECATEGORIES
#define MOBILESDKPRIVATE_COMMON_DB_STORECATEGORIES

#include "MobileSDKprivate/common/db/DBTable.h"

class StoreCategories : public DBTable
{
private:
	msdk_u32                m_id;
	char_utf8*              m_description;
    char_utf8*              m_startDate;
    char_utf8*              m_endDate;
    msdk_u32                m_recursiveTime;
    msdk_u32                m_weight;
public:
    StoreCategories();
    ~StoreCategories();
	static std::vector<StoreCategories*>	FindAll();
	static void	DeleteAll();
	static StoreCategories* FindById(const char_utf8* p_id);
	bool		Persist();
    static void MultiPersist(StoreCategories** p_items, int p_size);

	inline const msdk_u32                       GetId() { return m_id; };
	inline const char_utf8*                     GetDescription() { return m_description; };
   	inline const char_utf8*                     GetStartDate() { return m_startDate; };
	inline const char_utf8*                     GetEndDate() { return m_endDate; };
	inline const msdk_u32                       GetRecursiveTime() { return m_recursiveTime; };
	inline const msdk_u32                       GetWeight() { return m_weight; };

    inline void SetId(msdk_u32 value) { m_id = value; };
	inline void SetDescription(char_utf8* value) { m_description = value; };
    inline void SetStartDate(char_utf8* value) { m_startDate = value; };
    inline void SetEndDate(char_utf8* value) { m_endDate = value; };
    inline void SetRecursiveTime(msdk_u32 value) { m_recursiveTime = value; };
    inline void SetWeight(msdk_u32 value) { m_weight = value; };

};

#endif // MOBILESDKAPI_STORE_CATEGORIES_H_
