#ifndef MOBILESDKPRIVATE_COMMON_DB_STOREITEMS
#define MOBILESDKPRIVATE_COMMON_DB_STOREITEMS

#include "MobileSDKprivate/common/db/DBTable.h"
#include "MobileSDKprivate/iab/IAPProduct.h"

class StoreItems : public DBTable
{
private:
	msdk_u32                m_id;
    char_utf8*              m_title;
	char_utf8*              m_description;
    msdk_ProductType        m_type;
    char_utf8*              m_minVersion;
    char_utf8*              m_maxVersion;
    std::map<char_utf8*, char_utf8*, CharCompFunctor>	m_args;
public:
    StoreItems();
    ~StoreItems();
	static std::vector<StoreItems*>	FindAll();
	static void	DeleteAll();
	static StoreItems* FindById(const char_utf8* p_id);
	bool		Persist();
    static void MultiPersist(StoreItems** p_items, int p_size);

	inline const msdk_u32                       GetId() { return m_id; };
    inline const char_utf8*                     GetTitle() { return m_title; };
	inline const char_utf8*                     GetDescription() { return m_description; };
   	inline const char_utf8*                     GetMinVersion() { return m_minVersion; };
	inline const char_utf8*                     GetMaxVersion() { return m_maxVersion; };
    inline msdk_ProductType                     GetType() { return m_type; };
	inline const std::map<char_utf8*, char_utf8*, CharCompFunctor>&       GetArgs() { return m_args; };

    inline void SetId(msdk_u32 value) { m_id = value; };
    inline void SetTitle(char_utf8* value) { m_title = value; };
	inline void SetDescription(char_utf8* value) { m_description = value; };
    inline void SetMinVersion(char_utf8* value) { m_minVersion = value; };
    inline void SetMaxVersion(char_utf8* value) { m_maxVersion = value; };
    inline void SetType(msdk_ProductType value) { m_type = value; };
	inline void AddArg(char_utf8* p_key, char_utf8* p_value) { m_args[p_key] = p_value; };
    inline void ClearArgs() { m_args.clear(); };
};

#endif // MOBILESDKAPI_STORE_ITEMS_H_
