#ifndef MOBILESDKPRIVATE_COMMON_DB_STOREPRIMARY
#define MOBILESDKPRIVATE_COMMON_DB_STOREPRIMARY

#include "MobileSDKprivate/common/db/DBTable.h"
#include "MobileSDKprivate/iab/IAPProduct.h"

class StorePrimary : public DBTable
{
private:
	msdk_u32                        m_packId;
    msdk_u32                        m_bundleId;
	char_utf8*                      m_storeId;
    char_utf8*                      m_name;
    char_utf8*                      m_description;
    char_utf8*                      m_formattedPrice;
    msdk_ProductType				m_type;
    float                           m_price;
    char_utf8*                      m_priceSymbol;
    std::map<msdk_u32, msdk_u32>	m_gettings;
    char_utf8*                      m_minVersion;
    char_utf8*                      m_maxVersion;
    char_utf8*                      m_categoryTags;
    char_utf8*                      m_startDate;
    char_utf8*                      m_endDate;
    char_utf8*                      m_icon;
    msdk_u32                        m_weight;
    std::vector<char_utf8*>         m_args;

public:
    StorePrimary();
    ~StorePrimary();
	static std::vector<StorePrimary*>	FindAll();
	static void	DeleteAll();
	static StorePrimary FindById(const char_utf8* p_id);
	bool		Persist();
    static void MultiPersist(StorePrimary** p_items, int p_size);
    static void UpdateFromIap(const Array_msdk_IAPProduct* p_products);

	inline const msdk_u32                       GetPackId() { return m_packId; };
    inline const msdk_u32                       GetBundleId() { return m_bundleId; };
	inline const char_utf8*                     GetStoreId() { return m_storeId; };
    inline const char_utf8*                     GetName() { return m_name; };
    inline const char_utf8*                     GetDescription() { return m_description; };
    inline const char_utf8*                     GetFormattedPrice() { return m_formattedPrice; };
    inline float                                GetPrice() { return m_price; };
    inline const char_utf8*                     GetPriceSymbol() { return m_priceSymbol; };
    inline const char_utf8*                     GetMinVersion() { return m_minVersion; };
    inline const char_utf8*                     GetMaxVersion() { return m_minVersion; };
    inline const char_utf8*                     GetStartDate() { return m_startDate; };
    inline const char_utf8*                     GetEndDate() { return m_endDate; };
    inline const char_utf8*                     GetIcon() { return m_icon; };
    std::vector<msdk_u32>                       GetCategoryTags();
    inline const char_utf8*                     GetCategoryTagsStr() { return m_categoryTags; };
    inline const std::vector<char_utf8*>&       GetArgs() { return m_args; };
    inline msdk_ProductType      				GetType() { return m_type; };
    inline const std::map<msdk_u32, msdk_u32>&  GetGettings() { return m_gettings; };
    inline msdk_u32                             GetWeight() { return m_weight; };

	inline void SetPackId(msdk_u32 value) { m_packId = value; };
    inline void SetBundleId(msdk_u32 value) { m_bundleId = value; };
    inline void SetStoreId(char_utf8* value) { m_storeId = value; };
    inline void SetName(char_utf8* value) { m_name = value; };
    inline void SetDescription(char_utf8* value) { m_description = value; };
    inline void SetMinVersion(char_utf8* value) { m_minVersion = value; };
    inline void SetMaxVersion(char_utf8* value) { m_maxVersion = value; };
    inline void SetFormattedPrice(char_utf8* value) { m_formattedPrice = value; };
    inline void SetPrice(float value) { m_price = value; };
    inline void SetPriceSymbol(char_utf8* value) { m_priceSymbol = value; };
    inline void SetCategoryTag(char_utf8* p_tag) { m_categoryTags = p_tag; };
    inline void SetStartDate(char_utf8* value) { m_startDate = value; };
    inline void SetEndDate(char_utf8* p_tag) { m_endDate = p_tag; };
    inline void SetIcon(char_utf8* p_icon) { m_icon = p_icon; };
	inline void AddGetting(msdk_u32 p_itemId, msdk_u32 p_amount) { m_gettings[p_itemId] = p_amount; };
    inline void AddArg(msdk_u32 index, char_utf8* value) { m_args[index] = value; };
    inline void SetType(msdk_ProductType type) { m_type = type; };
};

#endif // MOBILESDKAPI_STORE_PRIMARY_H_
