#ifndef MOBILESDKPRIVATE_COMMON_DB_STOREPROMOS
#define MOBILESDKPRIVATE_COMMON_DB_STOREPROMOS

#include "MobileSDKprivate/common/db/DBTable.h"
#include "MobileSDKprivate/iab/IAPProduct.h"

class StorePromos : public DBTable
{
private:
	msdk_u32                m_id;
    char_utf8*              m_start;
	char_utf8*              m_end;
    char_utf8*              m_description;
    msdk_u32                m_percentageRebate;
    msdk_u32                m_percentageBonus;
    std::vector<msdk_u32>   m_items;
    msdk_u32                m_weight;
public:
    StorePromos();
    ~StorePromos();
	static std::vector<StorePromos*>	FindAll();
	static void	DeleteAll();
	static StorePromos FindById(const char_utf8* p_id);
	bool		Persist();

	inline msdk_u32                             GetId() { return m_id; };
    inline const char_utf8*                     GetStart() { return m_start; };
	inline const char_utf8*                     GetEnd() { return m_end; };
    inline const char_utf8*                     GetDescription() { return m_description; };
    inline msdk_u32                             GetPercentageRebate() { return m_percentageRebate; };
    inline msdk_u32                             GetPercentageBonus() { return m_percentageBonus; };
	inline const std::vector<msdk_u32>&         GetItems() { return m_items; };
    inline msdk_u32                             GetWeight() { return m_weight; };

    inline void SetId(msdk_u32 value) { m_id = value; };
    inline void SetStart(char_utf8* value) { m_start = value; };
    inline void SetEnd(char_utf8* value) { m_end = value; };
	inline void SetDescription(char_utf8* value) { m_description = value; };
    inline void SetPercentageRebate(msdk_u32 value) { m_percentageRebate = value; };
    inline void SetPercentageBonus(msdk_u32 value) { m_percentageBonus = value; };
    inline void SetWeight(msdk_u32 value) { m_weight = value; };
	inline void AddItem(msdk_u32 p_value) { m_items.push_back(p_value); };
};

#endif // MOBILESDKAPI_STORE_PROMOS_H_
