#ifndef MOBILESDKPRIVATE_COMMON_DB_STORESECONDARY
#define MOBILESDKPRIVATE_COMMON_DB_STORESECONDARY

#include "MobileSDKprivate/common/db/DBTable.h"

class StoreSecondary : public DBTable
{
private:
	msdk_u32                        m_barterId;
    char_utf8*                      m_name;
    char_utf8*                      m_description;
    msdk_u32                        m_priceItemId;
    msdk_u32                        m_priceAmount;
    std::map<msdk_u32, msdk_u32>	m_gettings;
    char_utf8*                      m_minVersion;
    char_utf8*                      m_maxVersion;
    char_utf8*                      m_categoryTags;
    char_utf8*                      m_startDate;
    char_utf8*                      m_endDate;
    char_utf8*                      m_icon;
    msdk_u32                        m_occurence;
    msdk_u32                        m_weight;
    std::vector<char_utf8*>         m_args;

public:
    StoreSecondary();
    ~StoreSecondary();
	static std::vector<StoreSecondary*>	FindAll();
	static void	DeleteAll();
	static StoreSecondary FindById(const char_utf8* p_id);
	bool		Persist();
    static void MultiPersist(StoreSecondary** p_items, int p_size);

	inline msdk_u32                 GetBarterId() { return m_barterId; };
    inline const char_utf8*         GetName() { return m_name; };
    inline const char_utf8*         GetDescription() { return m_description; };
    inline const msdk_u32           GetPriceItemId() { return m_priceItemId; };
    inline msdk_u32                 GetPriceAmount() { return m_priceAmount; };
    inline const char_utf8*         GetMinVersion() { return m_minVersion; };
    inline const char_utf8*         GetMaxVersion() { return m_maxVersion; };
    inline const char_utf8*         GetStartDate() { return m_startDate; };
    inline const char_utf8*         GetEndDate() { return m_endDate; };
    inline const char_utf8*         GetIcon() { return m_icon; };
    inline const char_utf8*         GetCategoryTagsStr() { return m_categoryTags; };
    std::vector<msdk_u32>           GetCategoryTags();
    inline msdk_u32                 GetOccurence() { return m_occurence; };
    inline const std::map<msdk_u32, msdk_u32>& GetGettings() { return m_gettings; };
    inline const std::vector<char_utf8*>& GetArgs() { return m_args; };
    inline msdk_u32                 GetWeight() { return m_weight; };

	inline void SetBarterId(msdk_u32 value) { m_barterId = value; };
    inline void SetName(char_utf8* value) { m_name = value; };
    inline void SetDescription(char_utf8* value) { m_description = value; };
    inline void SetPriceItemId(msdk_u32 value) { m_priceItemId = value; };
    inline void SetPriceAmount(msdk_u32 value) { m_priceAmount = value; };
    inline void SetMinVersion(char_utf8* value) { m_minVersion = value; };
    inline void SetMaxVersion(char_utf8* value) { m_maxVersion = value; };
    inline void SetStartDate(char_utf8* value) { m_startDate = value; };
    inline void SetEndDate(char_utf8* value) { m_endDate = value; };
    inline void SetIcon(char_utf8* value) { m_icon = value; };
    inline void SetOccurence(msdk_u32 value) { m_occurence = value; };
	inline void AddGetting(msdk_u32 p_itemId, msdk_u32 p_amount) { m_gettings[p_itemId] = p_amount; };
    inline void SetCategoryTag(char_utf8* p_tag) { m_categoryTags = p_tag; };
    inline void AddArg(msdk_u32 index, char_utf8* value) { m_args[index] = value; };
};

#endif // MOBILESDKAPI_STORE_SECONDARY_H_
