#ifndef MOBILESDKPRIVATE_COMMON_DB_STOREVIEWS
#define MOBILESDKPRIVATE_COMMON_DB_STOREVIEWS

#include "MobileSDKprivate/common/db/DBTable.h"
#include "MobileSDKprivate/dynamicStore/DynamicStore.h"


enum msdk_StoreType
{
    MSDK_STORE_PRIMARY,
    MSDK_STORE_SECONDARY,
    MSDK_STORE_ERROR
};

union itemsUnion
{
    Array_msdk_PrimaryStoreItem*        primaryItems;
    Array_msdk_SecondaryStoreItem*      secondaryItems;
};

struct msdk_StoreViewResult
{
    msdk_StoreType   type;
    itemsUnion items;
};

class StoreViews : public DBTable
{
private:
    char_utf8*                      m_name;
    char_utf8*                      m_formula;
    msdk_StoreType                  m_store;
public:
    StoreViews();
	static std::vector<StoreViews*>	FindAll();
	static void	DeleteAll();
	static StoreViews FindByName(const char_utf8* p_name);
	bool		Persist();
    msdk_StoreViewResult*           Execute();

    inline const char_utf8*         GetName() { return m_name; };
    inline const char_utf8*         GetFormula() { return m_formula; };

    inline void SetName(char_utf8* value) { m_name = value; };
    inline void SetFormula(char_utf8* value) { m_formula = value; };
};

#endif // MOBILESDKAPI_STORE_VIEWS_H_
