#ifndef MOBILESDKPRIVATE_COMMON_HTTP_HTTPINTERFACE
#define MOBILESDKPRIVATE_COMMON_HTTP_HTTPINTERFACE

#include "MobileSDKprivate/common/Utils.h"
#include "MobileSDKprivate/common/FileSystem.h"

enum msdk_HttpRequestType
{
	MSDK_POST,
	MSDK_GET,
    MSDK_PUT,
    MSDK_DELETE,
	
	MSDK_HEAD,
};

enum msdk_HttpRequestBodyType
{
    MSDK_PARAM,
    MSDK_DATA,
    MSDK_DATA_TO_FREE,
    MSDK_NO_BODY_ADDED,
};

typedef struct msdk_HttpInterface
{
	void	(*Init)();
	void	(*UnInit)();

    void 	(*SetRawData)(struct msdk_HttpInterface*, const char_utf8* data, bool copyData);
	void	(*AddParameter)(struct msdk_HttpInterface*, const char_utf8* p_key, const char_utf8* p_value);
	void	(*AddHeader)(struct msdk_HttpInterface*, const char_utf8* p_value);
	void	(*Start)(struct msdk_HttpInterface*);
	struct	msdk_HttpInterface*	(*CreateInstance)();
	void	(*DestroyInstance)(struct msdk_HttpInterface*);
    void    (*UploadFile)(struct msdk_HttpInterface* p_interface, const char_utf8* p_filePath, msdk_FileArea p_area, const char_utf8* fieldName);
    void    (*UploadBuffer)(struct msdk_HttpInterface* p_interface, const char_utf8* p_buffer, msdk_u32 p_size, const char_utf8* fieldName);
	const char_utf8*            url;
	msdk_HttpRequestType        type;
	char_utf8*                  headers;
	msdk_u32                    headersLength;
	char_utf8*                  content;
	msdk_u32                    contentLength;
	void*                       internal;
    msdk_HttpRequestBodyType    requestBodyType;
    msdk_u32                    responseCode;
}msdk_HttpInterface;

#endif // MOBILE_SDK_API_HTTPINTERFACE_H
