#ifndef MOBILESDKPRIVATE_COMMON_HTTP_HTTPREQUEST
#define MOBILESDKPRIVATE_COMMON_HTTP_HTTPREQUEST

#include "MobileSDKprivate/common/http/HttpInterface.h"
#include "MobileSDKprivate/common/FileSystem.h"

#ifdef MSDK_BUILD_LIB

	#include "MobileSDKprivate/common/Utils.h"

	class msdk_HttpRequest
	{
	public:
		static	void RegisterInterface(msdk_HttpInterface* p_interface);
		static	void RemoveInterface();

		msdk_HttpRequest(msdk_HttpRequestType);
		msdk_HttpRequest(msdk_HttpRequestType, const char_utf8*);
		~msdk_HttpRequest();
		void 					SetUrl(const char_utf8* url);
	    void 					SetRawData(const char_utf8* data, bool copyData);
	    void                    UploadFile(const char_utf8* p_filePath, msdk_FileArea p_area, const char_utf8* fieldName);
	    void                    UploadBuffer(const char_utf8 *p_buffer, msdk_u32 p_size, const char_utf8* fieldName);
		void					AddParameter(const char_utf8* p_key, const char_utf8* p_value);
	    void					AddHeader(const char_utf8* p_value);

		void					Start();

		void					SetRequestType(msdk_HttpRequestType p_type);
		char_utf8*				GetResult();
		msdk_u32				GetResultLength();
		char_utf8*				GetHeaderResult();
		msdk_u32				GetHeaderResultLength();
        msdk_u32                GetResponseCode();
		inline const std::map<const char_utf8*, const char_utf8*, CharCompFunctor>& GetHeaders() { return m_headers; };
	private:
		static	msdk_HttpInterface*	s_interface;
		msdk_HttpInterface*			m_interface;
		std::map<const char_utf8*, const char_utf8*, CharCompFunctor>	m_headers;
	};

#endif //! MSDK_BUILD_LIB

void	HttpRequest_RegisterInterface(msdk_HttpInterface* p_interface);

#endif //! MOBILE_SDK_API_HTTPREQUEST_H
