#ifndef MOBILESDKPRIVATE_SOCIAL_FACEBOOKGRAPHAPI
#define MOBILESDKPRIVATE_SOCIAL_FACEBOOKGRAPHAPI

//==========================================================================================
// Mobile SDK internal stuff
#ifdef MSDK_BUILD_LIB

	#include "MobileSDKprivate/common/Utils.h"
	#include "MobileSDKprivate/common/RequestPool.h"
	#include "MobileSDKprivate/social/UserInfo.h"


	#ifdef UBI_ANDROID
		#include <jni.h>
		#include <json.h>
	#endif // UBI_ANDROID

	#if defined(UBI_WIN8) || defined(UBI_WP8)
	#include <json.h>
	#endif

	namespace MobileSDKAPI
	{
		namespace SocialAPI
		{
			class FacebookGraphAPI
			{
				// =============================================================================
				// Private attributs
				private:

				#if defined(UBI_ANDROID) || defined(UBI_WIN8) || defined(UBI_WP8)
				static RequestPool<char_utf8*, FACEBOOK_GRAPH_API>		s_RequestPool;
				#endif // defined(UBI_ANDROID) || defined(UBI_WIN8)

				// =============================================================================
				// Public functions
				public:

				#if defined(UBI_ANDROID) || defined(UBI_WIN8) || defined(UBI_WP8)

	            #ifdef UBI_ANDROID
	            static void 					GraphAPICallback		(JNIEnv* env, jobject thiz, jboolean p_sucess, jstring p_message, jbyte p_requestID);
	            #endif

	            #if defined(UBI_WIN8) || defined(UBI_WP8)
	            static void 					GraphAPICallback		(const char_utf8* p_message, msdk_u8 p_requestID);
				static unsigned int				RequestThread			(void* p_param);
	            #endif

				static msdk_s8 					CallGraphAPI			(const char_utf8* const p_query, const char_utf8* const p_httpMethod, const charCharMap& p_params, const charCharMap* p_paramsBinary = NULL);
				static msdk_Status 				StatusGraphAPI			(msdk_s8 p_requestID);
				static const char_utf8*			ResultGraphAPI			(msdk_s8 p_requestID);
	            static void						ReleaseGraphAPI			(msdk_s8 p_requestID);

	            static void 					ParseUserInfo			(json_value* p_json, msdk_UserInfo* res);
				#endif // defined(UBI_ANDROID) || defined(UBI_WIN8)
				// =============================================================================
			};
		}
	}

#endif
//==========================================================================================
#endif // MOBILE_SDK_API_FACEBOOKGRAPHAPI_H
