#ifndef MOBILESDKPRIVATE_SOCIAL_COMMUNICATION_BASEMESSAGE
#define MOBILESDKPRIVATE_SOCIAL_COMMUNICATION_BASEMESSAGE
	#include "MobileSDK/social/communication/BaseMessage.h"

#ifdef MSDK_BUILD_LIB

	typedef struct msdk_Link
	{
		char_utf8* link;
		char_utf8* facebookName;
		char_utf8* facebookCaption;
		char_utf8* facebookDescription;
	}msdk_Link;

	typedef struct msdk_Tag
	{
		char_utf8* facebookTag;
	}msdk_Tag;

	typedef struct msdk_Icon
	{
		char_utf8* facebookIcon;
	}msdk_Icon;

	typedef struct msdk_ActionObject // ie Facebook story
	{
		char_utf8*              facebookAction; //
		char_utf8*              facebookObjectType; //
		char_utf8*              facebookObject; // for app owned object, url hosting the object to be shared like:
	    char_utf8*              objectTitle; //
	    char_utf8*              objectImage; //
	    char_utf8*              objectUrl; //
	    char_utf8*              objectDescription; //
	    msdk_s8                 isExplicit; //
	    Array_msdk_key_value*   actionParameters; //
	    Array_msdk_key_value*   objectParameters; //
	}msdk_ActionObject;

	DECLARE_ARRAYS(msdk_Link);
	DECLARE_ARRAYS(msdk_Tag);
	DECLARE_ARRAYS(msdk_Icon);
	DECLARE_ARRAYS(msdk_ActionObject);

	typedef struct msdk_extras
	{
		PointerArray_msdk_Link* links;
		msdk_FacebookMode		useFacebookDialog;
		PointerArray_msdk_Tag*	tags;
	    PointerArray_char_utf8* localPictures;
		PointerArray_char_utf8* pictureUrls;
		PointerArray_char_utf8* videoUrls;
		PointerArray_msdk_Icon*	icons;
		msdk_ActionObject*      actionObject;
	}msdk_extras;

#endif

/*
///
/// Structure to send or post messages to a user
///
typedef struct msdk_Message
{
    const msdk_UserInfo* 	recipient;
    char_utf8* 		message;

#ifdef MSDK_BUILD_LIB
    msdk_extras* 		extras;
#else
    void* internalBatching;
#endif
}msdk_Message;
*/

#endif // MESSAGING_H
