#ifndef MOBILESDKPRIVATE_SOCIAL_INTERFACE_COMMUNICATION_INTERFACE
#define MOBILESDKPRIVATE_SOCIAL_INTERFACE_COMMUNICATION_INTERFACE

#include "MobileSDKprivate/common/Utils.h"
#include "MobileSDKprivate/social/communication/BaseMessage.h"
#include "MobileSDKprivate/social/communication/Invitation.h"

typedef struct msdk_CommunicationInterface
{
	void		(*PostWall)(msdk_BaseMessage* p_message);
	msdk_Status	(*StatusWall)();
	msdk_Result	(*ResultWall)();
    void        (*ReleaseWall)();

	void		(*EndCommunication)();

    msdk_Result (*WallOpen)(const char_utf8* p_wallId);

    void        (*CallIsLiked)(const char_utf8* p_wallId);
    msdk_Status (*StatusIsLiked)();
    msdk_Result (*ResultIsLiked)();
    void        (*ReleaseIsLiked)();

	void		(*CallInvite)(const char_utf8* p_title, const char_utf8* p_message, Array_msdk_UserInfo* p_users, Array_msdk_key_value* p_extraDatas);
	msdk_Status (*StatusInvite)();
	msdk_Result (*ResultInvite)();
    void        (*ReleaseInvite)();

    void                    (*CallSendRequest)(msdk_InvitationRequest* p_request);
    msdk_Status             (*StatusSendRequest)();
    msdk_InvitationResult*  (*ResultSendRequest)();
    void                    (*ReleaseSendRequest)();

    void                            (*CallGetRequests)();
    msdk_Status                     (*StatusGetRequests)();
    Array_msdk_InvitationResult*    (*ResultGetRequests)();
    void                            (*ReleaseGetRequests)();

    msdk_s8     (*CallDeleteRequest)(const char_utf8* p_requestId);
    msdk_Status (*StatusDeleteRequest)(msdk_s8 p_requestId);
    msdk_Result (*ResultDeleteRequest)(msdk_s8 p_requestId);
    void        (*ReleaseDeleteRequest)(msdk_s8 p_requestId);

    msdk_s8                 (*CallReadRequest)(const char_utf8* p_requestId);
    msdk_Status             (*StatusReadRequest)(msdk_s8 p_requestId);
    Array_msdk_key_value*   (*ResultReadRequest)(msdk_s8 p_requestId);
    void                    (*ReleaseReadRequest)(msdk_s8 p_requestId);
}msdk_CommunicationInterface;

#endif //MOBILE_SDK_COMMUNICATION_INTERFACE_H
