#ifndef MOBILESDKPRIVATE_SOCIAL_PROFILE_GAMEDATAMANAGER
#define MOBILESDKPRIVATE_SOCIAL_PROFILE_GAMEDATAMANAGER

#include "MobileSDKprivate/common/Utils.h"
#include "MobileSDKprivate/common/CriticalSection.h"
#include "MobileSDKprivate/common/Thread.h"
#include "MobileSDKprivate/social/interface/Social_Interface.h"
#include "MobileSDKprivate/social/profile/UserProfile.h"
#include <json.h>

namespace MobileSDKAPI
{
    class GameDataManager
    {
    private:
        static GameDataManager* instance;
        GameDataManager();

        static charCharMap                     m_publicGameData;
        static charCharMap                     m_privateGameData;
        static charCharMap                     m_publicToUpdate;
        static charCharMap                     m_privateToUpdate;
        static std::list<char_utf8*>           m_publicToDelete;
        static std::list<char_utf8*>           m_privateToDelete;
        static msdk_Status                     m_dataStatus;
        static msdk_Result                     m_dataResult;
        static msdk_Result                     m_dataOnlineResult;
        static msdk_Status                     m_saveDataOnlineStatus;
        static msdk_Result                     m_saveDataOnlineResult;

        static GameDataMergeCallback*          m_callback;

        static unsigned int    SaveThread(void* p_param);
        static unsigned int    DataThread(void* p_param);
        static void 			MergeData(void* p_param);

        char_utf8*      FeedFromMaps(charCharMap& p_privateData, charCharMap& p_publicData);
        void            MapsFromFeed(charCharMap& p_privateData, charCharMap& p_publicData, const char_utf8* p_feed);
    public:
        static GameDataManager*         Instance();
        //GameData
        void                     RegisterMergeCallback(GameDataMergeCallback p_callback);

        void                     UpdateGameData(const char_utf8* p_key, const char_utf8* p_value, msdk_UserProfileDomain p_domain);
        void                     DeleteGameData(const char_utf8* p_key, msdk_UserProfileDomain);
        const char_utf8*         GetGameData(const char_utf8* p_key, msdk_UserProfileDomain p_domain);
        void                     SaveGameData();
        msdk_Status              SaveGameDataOnlineStatus();
        msdk_Result              SaveGameDataOnlineResult();

        void                     CallGameData();
        msdk_Status              StatusGameData();
        msdk_Result              ResultGameData();
        msdk_Result              ResultGameDataOnline();
        void                     ReleaseGameData();

        const char_utf8*         GetLocalSave();
    };
}

#endif
