#ifndef MOBILESDKPRIVATE_SOCIAL_PROFILE_GAMEDATAMANAGER
#define MOBILESDKPRIVATE_SOCIAL_PROFILE_GAMEDATAMANAGER

#include "MobileSDKprivate/common/Utils.h"
#include "MobileSDKprivate/common/Thread.h"
#include "MobileSDK/social/Score.h"
#include "MobileSDKprivate/social/Leaderboard.h"

namespace MobileSDKAPI
{
    class LeaderboardManager
    {
    private:
        struct RegisterScoreInfo
        {
            msdk_Status status;
            msdk_Result result;
            msdk_s8     requestId;
            msdk_Score* score;
            ThreadStruct thread;
        };
        
        static LeaderboardManager* instance;
        LeaderboardManager();
        std::map<msdk_s8, RegisterScoreInfo*>    registerRequests;
        static unsigned int RegisterScoreThread(void* p_param);
        static unsigned int CallScoresThread(void* p_param);
        static unsigned int CallSurroundingScoresThread(void* p_param);
        static unsigned int CallPlayerScoresThread(void* p_param);
        static unsigned int StatsThread(void* p_param);
        static void ParseResult(const char_utf8* result);
        ThreadStruct    scoresThread;
        ThreadStruct    playerScoresThread;
        ThreadStruct    statsThread;
        static msdk_Status     scoresStatus;
        static Array_msdk_Score scores;
        static msdk_Status      statsStatus;
        static char_utf8*       statsResult;
    public:
        static LeaderboardManager*         Instance();
        
        msdk_s8 	CallRegisterScore(msdk_Score* p_score);
        msdk_Status StatusRegisterScore(msdk_s8 p_requestId);
        msdk_Result ResultRegisterScore(msdk_s8 p_requestId);
        void ReleaseRegisterScore(msdk_s8 p_requestId);
        
        
        void 	CallScores(msdk_Service p_service, const char_utf8* p_leaderBoardId, msdk_u32 p_location, msdk_u32 p_length, msdk_LeaderboardOptions p_options);
        void 	CallSurroundingScores(msdk_Service p_service, const char_utf8* p_leaderBoardId, msdk_u32 p_scoresNumber, msdk_LeaderboardOptions p_options);
        void 	CallPlayersScores(msdk_Service p_service, const char_utf8* p_leaderBoardId, PointerArray_msdk_UserInfo*, msdk_LeaderboardOptions p_options);
        msdk_Status StatusScores();
        Array_msdk_Score* ResultScores();
        void ReleaseScores();
        
        void CallStats(const char_utf8* p_leaderboardId, msdk_LeaderboardStatType p_type);
        msdk_Status StatusStats();
        const char_utf8* ResultStats();
        void ReleaseStats();
    };
}

#endif
