#ifndef MOBILESDKPRIVATE_SOCIAL_PROFILE_MERGEPROFILE
#define MOBILESDKPRIVATE_SOCIAL_PROFILE_MERGEPROFILE

#include "MobileSDKprivate/common/Utils.h"
#include "MobileSDKprivate/common/CriticalSection.h"
#include "MobileSDKprivate/ui/Webview.h"
#include "MobileSDKprivate/social/UserInfo.h"
//#include "MobileSDK/social/profile/UserProfilemanager.h"
namespace MobileSDKAPI
{
	class MergeProfile
	{
	public:
		struct FedInfos
		{
			FedInfos()
				: fedId(NULL)
				, accessToken(NULL)
				, networkIds()
			{

			}
            ~FedInfos();

			char_utf8* fedId;
			char_utf8* accessToken;
			std::map<msdk_NetworkId, const msdk_UserInfo*> networkIds;
		};

		enum NetworkStatus
		{
			MSDK_CAN_MERGE,
			MSDK_CANNOT_MERGE,
			MSDK_ALREADY_MERGE
		};
	private:
        static FedInfos*    pendingFedId1;
        static FedInfos*    pendingFedId2;

		static FedInfos*    deviceFedId;
		static FedInfos*    storedFedId;
        static bool         mergeInProgress;
        static bool         mergeResult;
        static bool         accountSelectionInProgress;
        static FedInfos*    accountSelectionresult;
        static bool         unregisterAccountInProgress;
        static CriticalSectionStruct    lock;
        static bool                     isInit;
        static bool                     isAutoConnected;

        static bool                     deviceResolutionStarted;

		static FedInfos* ParseFederateId(const char_utf8* p_json);
		static void StoreFederatedId(FedInfos* p_param);

		static NetworkStatus Reconciliate(msdk_NetworkId p_networkId, std::pair<const msdk_UserInfo*, const char_utf8*>& p_userCredential);

        //static void MergeLinkPressed(Webview* p_view, const char_utf8* p_link);
       // static void ChooseLinkPressed(Webview* p_view, const char_utf8* p_link);
       // static void UnregisterLinkPressed(Webview* p_view, const char_utf8* p_link);
        static char_utf8* GetFedChoice(FedInfos* fed1);
	public:
		static FedInfos* activeFedId;
		static std::vector<FedInfos*> availableFedIds;
		//static std::map<msdk_NetworkId, std::pair<const char_utf8*, const char_utf8*> > connectedSocialNetworks;
        static std::map<msdk_NetworkId, std::pair<const msdk_UserInfo*, const char_utf8*> > connectedSocialNetworks;

		static void InitDeviceFedId();
		static void InitStoredFedId();
        static void OnAutoConnectionEnded();

		static void SetConnectedNetwork(msdk_NetworkId p_networkId, const msdk_UserInfo* p_user, const char_utf8* p_networkToken);

        inline static bool IsDeviceResolutionStarted() { return deviceResolutionStarted; };
		static void ResolveNow();
		static void ResolveWithoutSocialNetwork(); // For quick fix in registerDeviceThread
		static void ResolveWithSocialNetwork();
        static void DisplayMergeWindow(MergeProfile::FedInfos* fed1, MergeProfile::FedInfos* fed2);
        static void DisplayAccountSelectionWindow(MergeProfile::FedInfos* fed1, MergeProfile::FedInfos* fed2);
        static void DisplayUnRegisterWindow(MergeProfile::FedInfos*);
        static FedInfos* RegisterNetwork(msdk_NetworkId p_networkId, const char_utf8* p_token);
        static void UnRegisterNetwork(msdk_NetworkId p_networkId);

        static void             OnMergeAction(msdk_s8 p_acceptMerge);
        static void             OnAccountSelected(msdk_ProfileInfo* p_selectedProfile);
        static void             OnUnregisterAction();
#ifdef MSDK_UNITY_BINDING
        static void             DefinePointers(long long displayPointer, long long mergePointer, long long unregisterPointer);
#endif
	};
}

#endif // MOBILE_SDK_API_MERGEPROFILE_H
