#ifndef MOBILESDKPRIVATE_TRACKING_ANALYTICS
#define MOBILESDKPRIVATE_TRACKING_ANALYTICS
	#include "MobileSDK/tracking/Analytics.h"

// ==================================================================================
// Mobile SDK internal stuff
#ifdef MSDK_BUILD_LIB

	#include "MobileSDKprivate/common/Utils.h"

	extern const char_utf8* MSDK_EVENT_START_SESSION;
	extern const char_utf8* MSDK_EVENT_END_SESSION;
	extern const char_utf8* MSDK_EVENT_AUTHENTICATION;
	extern const char_utf8* MSDK_EVENT_ADVERTISEMENT;
	extern const char_utf8* MSDK_EVENT_PRIMARY_STORE_ENTRY;
	extern const char_utf8* MSDK_EVENT_IAP;
	extern const char_utf8* MSDK_EVENT_PRIMARY_STORE_EXIT;
	extern const char_utf8* MSDK_EVENT_SECONDARY_STORE_PURCHASE;
	extern const char_utf8* MSDK_EVENT_SECONDARY_STORE_EXIT;
	extern const char_utf8* MSDK_EVENT_LEADERBOARD_CHECK;
	extern const char_utf8* MSDK_EVENT_LEADERBOARD_UPLOAD;
	extern const char_utf8* MSDK_EVENT_VIRALITY;
	extern const char_utf8* MSDK_EVENT_NOTIFICATION;
	extern const char_utf8*	MSDK_SESSION_NUMBER;

	///
	/// Initialize the trackers
	/// @param  p_mask A mask of E_NetworkId to know which trackers initialize (GA, Flurry, ...)
	/// @param  p_parameters    A map of parameters needed to initialize the trackers
	///
	void    Analytics_Init();

	//
	// Stop the trackers
	//
	void    Analytics_Stop();

#endif
// ==================================================================================

#endif //! MOBILE_SDK_API_TRACKING_H
