#ifndef MOBILESDKPRIVATE_UI_WEBVIEW
#define MOBILESDKPRIVATE_UI_WEBVIEW

#include "MobileSDKprivate/common/Utils.h"

namespace MobileSDKAPI
{
    class Webview
    {
    public:
        enum UrlType
        {
            MSDK_URL_LOCAL,
            MSDK_URL_DISTANT
        };

        Webview(const char_utf8* p_url, UrlType p_type);
        ~Webview();

        typedef void (*urlLoadedSuccessCallback)(Webview* p_view, const char_utf8* p_url);
		typedef void (*urlLoadedFailCallback)(Webview* p_view, const char_utf8* p_url, const char_utf8* p_error);
		typedef void (*userCloseCallback)(Webview* p_view);
        typedef void (*linkPressed)(Webview* p_view, const char_utf8* p_link);

        urlLoadedSuccessCallback    onSuccess;
        urlLoadedFailCallback       onFail;
        userCloseCallback           onClose;
        linkPressed                 onLinkPressed;

        void    Display();
        void    Close();
        void    UpdateElement(const char_utf8* p_elementId, const char_utf8* p_atttribute, const char_utf8* p_value);
        void    LoadCssFile(const char_utf8* p_path);
        void    ExecuteScript(const char_utf8* p_script);
        void    AddToMainWindow();
        struct  WebviewComponent;
    private:
        WebviewComponent*   m_view;
    };
}

#endif
